package ztl.model;

import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class RestrictedArea
{
	private Map<String, Transit> transitMap = new HashMap<String, Transit>();
	private Set<String> authorizedPlates;
	
	public RestrictedArea(Collection<String> authorizedPlates)
	{
		this.authorizedPlates = new HashSet<String>(authorizedPlates);
	}
	
	public Ticket manageTransit(Transit transit)
	{
		if (authorizedPlates.contains(transit.getPlate())) return null;
		
		switch (transit.getDirection())
		{
			case ENTRY:
				transitMap.put(transit.getPlate(), transit);
				return null;
			case EXIT:
				return manageExitTransit(transit);
			default:
				throw new IndexOutOfBoundsException();
		}
	}

	private Ticket manageExitTransit(Transit exitTransit)
	{
		Transit entryTransit = transitMap.get(exitTransit.getPlate());
		if (entryTransit != null)
		{
			transitMap.remove(exitTransit.getPlate());
			return new Ticket(entryTransit, exitTransit);
		}
		return null;
	}
}
