package ztl.ui;

import java.awt.FlowLayout;
import java.awt.event.*;
import javax.swing.*;

import ztl.model.*;

public class MainFrame extends JFrame implements ActionListener
{
	private static final long serialVersionUID = 1L;

	private Controller controller;
	
	private DefaultListModel transitsListModel;
	private DefaultListModel ticketsListModel;
	private JLabel totalAmountLabel;

	private JButton avanti;

	public MainFrame(Controller controller)
	{
		this.controller = controller;

		initGui();
		showTransits();
	}

	private void showTransits()
	{
		for (Transit t : controller.getAllTransits())
		{
			transitsListModel.addElement(t);
		}
	}

	private void initGui()
	{
		getContentPane().setLayout(new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
		
		getContentPane().add(new JLabel("Elenco transiti registrati"));
		transitsListModel = new DefaultListModel();
		JList transitsList = new JList(transitsListModel);
		getContentPane().add(new JScrollPane(transitsList));
		
		avanti = new JButton("Elabora Prossimo Transito");
		getContentPane().add(avanti);
		avanti.addActionListener(this);
		
		ticketsListModel = new DefaultListModel();
		JList tickets = new JList(ticketsListModel);		
		getContentPane().add(new JScrollPane(tickets));
		
		JPanel bottomPanel = new JPanel();
		bottomPanel.setLayout(new FlowLayout());
		{
			bottomPanel.add(new JLabel("Totale incassato finora:   "));
			
			totalAmountLabel = new JLabel("0.00");
			bottomPanel.add(totalAmountLabel);
		}
		getContentPane().add(bottomPanel);
		
		pack();
	}

	public void actionPerformed(ActionEvent e)
	{
		if (transitsListModel.size() > 0)
		{
			Transit transit = (Transit)transitsListModel.get(0);
			transitsListModel.remove(0);
			Ticket ticket = controller.manageTransit(transit);
			if (ticket != null)
			{
				ticketsListModel.addElement(ticket);
				totalAmountLabel.setText("" + controller.getTotalAmount());
			}
			if (transitsListModel.size() == 0)
			{
				avanti.setEnabled(false);
			}
		}
	}
}
